#pragma once
#include "truedialog.h"
#include "NetMonBtn.h"
#include "colorbutton.h"
#include "truedialog.h"
#include "arrays.h"
#include "staticlink.h"

class CPropertiesPP;

struct SKINS
{
	char path[MAX_PATH];
	char author[255];
};

class CPropertiesDlg : public CTrueDialog
{
	CTArray<SKINS> m_skins;
	CONNECTION m_sampleData;

	BOOL lockInit;
public:
	CPropertiesPP* m_parent;

	CSkin m_skin;

	CPropertiesDlg(void);
	~CPropertiesDlg(void);
protected:
	void OnInitDialog(void);
	void OnCommand(DWORD itemID);
	void OnPaint(void);
	DWORD OnNotify(int idCtrl, LPNMHDR pnmh);
private:
	void RepaintButton(void);
	void FindSkins(void);
	DWORD GetCBData(DWORD cbID);
	void SetCBData(DWORD cbID, int data);
	void RedrawPreview(void);
	void InitSkin(void);
	void GetProperties(void);
};

class CCustConnectionsDlg : public CTrueDialog
{
	BOOL m_lockUpdate;
public:
	CPropertiesPP* m_parent;

	CCustConnectionsDlg(void);
	~CCustConnectionsDlg(void);
protected:
	void OnInitDialog(void);
	DWORD OnNotify(int idCtrl, LPNMHDR pnmh);
private:
	void SetVis(void);
public:
	void OnCommand(DWORD itemID);
private:
	void AddConnection(int idx);
	void FillForm(int idx);
	int GetCurConnection(void);
	void FillList(void);
};

class CAboutDlg : public CTrueDialog
{
	CxImage			icon;
	CStaticLink		m_urlHome;
	CStaticLink		m_urlSkins;
	CStaticLink		m_urlTLB;
protected:
	void OnPaint(void);
	void OnInitDialog(void);
public:
	CPropertiesPP* m_parent;

	CAboutDlg(void);
	~CAboutDlg(void);
};

class CPropertiesPP
{
	CPropertiesDlg		m_general;
	CCustConnectionsDlg	m_custCon;
	CAboutDlg			m_about;
public:
	HMODULE				m_hResource;
	HWND				m_hWnd;

	BTN_PROPERTIES	m_props;
	PARAMS			m_params[MAX_FIELDS];
	char			m_skinPath[MAX_PATH];
	char			m_onConnectSound[MAX_PATH];
	char			m_onDisconnectSound[MAX_PATH];
	char			m_run[MAX_PATH * 2];
	
	CTArray<CUSTOM_CONNECTION> m_customConnections;

	CPropertiesPP(void);
	~CPropertiesPP(void);
	DWORD Open(HWND hWnd, HMODULE hResModule);
	void Close(void);
};

class CAddConnectionDlg : public CTrueDialog
{
	CTArray<CUSTOM_CONNECTION> m_connections;
public:
	CUSTOM_CONNECTION m_connection;

	CAddConnectionDlg(void);
	~CAddConnectionDlg(void);
protected:
	void OnInitDialog(void);
	BOOL OnEndDialog(void);
};

